

import java.applet.*;
import java.awt.*;
import java.awt.image.*;


/* I am Neal McDonald, this is my code, take and eat, 
	but leave in a pointer to me:	www.workly.com
	*/
public class spotB extends water {
	int rayCount, wandering, colorLimit, backgrounding;
	int spotCornersX[], spotCornersY[];
	double ddirRay, maxLen, rayLens[];
	
	
	int getColorG(int x, int y) {
		int cx, cy, b;
		b=0; 
		cx = (int)((x-imageXoffset)/imageXscale);
		if ((cx>0) && (cx<imageX)) {
			cy = (int)((y-imageYoffset)/imageYscale);
			if ((cy>0) && (cy<imageY)) {
				b = colorGrid[cx][cy][0] + colorGrid[cx][cy][1] + colorGrid[cx][cy][2];
				b = b/3;
			}
		}
		return b;
	}

	void drawSpot(Graphics gr, double sx, double sy, int centerColor) {
		double d, len, lp, ln;
		int i, rx, ry, ox, oy, dc;
		boolean notDone, inside;
	
		for (i=0; i<rayCount; ++i) {
			d = i * ddirRay;
			notDone=true;
			len = 0.0;
			ox=(int)sx; oy=(int)sy;
			while ((notDone) && (len<maxLen)) {
				rx = (int)(ox + len * Math.cos(d)); 
				ry = (int)(oy + len * Math.sin(d)); 
				dc  = (getColorG(rx, ry))-centerColor;
				
				inside=true;
				if (rx<=imageXoffset) { inside=false; }
				if (ry<=imageYoffset) { inside=false; }
				if (rx>(imageXoffset+(imageX*imageXscale))) { inside=false; }
				if (ry>(imageYoffset+(imageY*imageYscale))) { inside=false; }
				
				if ((dc*dc<colorLimit) && inside && (len<maxLen)) {
					ox=rx; oy=ry;
					len += 0.5;
				} else {
					notDone = false;
					rayLens[i] = len;
				}
			}
		}
		
		ox=(int)sx; oy=(int)sy;
		for (i=0; i<rayCount; ++i) {
			if (i==0) { lp = rayLens[rayCount-1]; }
			else { lp = rayLens[i-1]; }
			if (i==(rayCount-1)) { ln = rayLens[0]; }
			else { ln = rayLens[i+1]; }
			len = (rayLens[i] + lp + ln) / 3.0; 
					
			//if (len>(lp+ln)) { len = lp*ln*0.5; }
			
			d = i * ddirRay;
			rx = (int)(ox + len * Math.cos(d)); 
			ry = (int)(oy + len * Math.sin(d)); 

			spotCornersX[i] = rx;
			spotCornersY[i] = ry;
		}
		
		gr.drawPolygon(spotCornersX, spotCornersY, rayCount);

	}


	
	void initPart(int which) {
		int r, g, b, cx, cy;
		double gx, gy;
		
		gx = Math.random() * imageX * imageXscale;
		gy = Math.random() * imageY * imageYscale;
		
		parts[which][DIR] = Math.random() *360.0;
		parts[which][JUMPED] = 0.0;
		parts[which][SPEED] = Math.random()*120.0;

		partColors[which] = Color.white;		
		parts[which][XPOS] = gx;
		parts[which][YPOS] = gy;
	}


	void initMore() {
		rayCount = 
			java.lang.Integer.parseInt(getParameter("rayCount"));
		wandering = 
			java.lang.Integer.parseInt(getParameter("wandering"));	
		maxLen = 
			(double)(java.lang.Integer.parseInt(getParameter("maxLen")));	
		colorLimit = 
			java.lang.Integer.parseInt(getParameter("dc"));	

		spotCornersX = new int[rayCount];
		spotCornersY = new int[rayCount];
		rayLens = new double[rayCount];
		ddirRay = 3.14159 *2.0/rayCount;
	}
	
	
	
	void drawPart(Graphics gr, int which) {
		int px, py, d, c, domark;
		Color ac;
		
		px = ((int)parts[which][XPOS]);
		py = ((int)parts[which][YPOS]);		
		c = getColorG(px, py); 
		ac = getColorC(px, py); 
		r_setColor(gr, Color.black);
		d = (int)(Math.random()*255.0);
		domark=0;
		if (c>128) { 
			if (d<c) { 
				r_setColor(gr, Color.white);
				domark=1; 
			} else {
				if (Math.random()<0.2) {
					domark=1;
					r_setColor(gr, Color.black);
				}
			}
		} else {
			if (d>c) {
				domark=1;
				r_setColor(gr, Color.black);
			} else {
				if (Math.random()<0.2) {
					domark=1;
					r_setColor(gr, Color.white);
				}
			}
		}
		if (domark==1) {
			drawSpot(gr, parts[which][XPOS], parts[which][YPOS], c); 
		}
	
	}
	
	void movePart(int which) {
		double dx, dy;
		int ix, jumped;
		
		ix = (int)(parts[which][DIR]) % 360;
		if (ix<0) ix+=360;
		parts[which][OX] = parts[which][XPOS];
		parts[which][OY] = parts[which][YPOS];
		parts[which][XPOS] += parts[which][SPEED] * cosines[ix];
		parts[which][YPOS] += parts[which][SPEED] * sines[ix];
			
		if (wandering==1) {
			parts[which][DIR] += Math.random() * 20.0-10.0;
		}
			
		jumped=0;
		if (parts[which][XPOS] > MAX_X) {
			parts[which][XPOS] = MIN_X;
			jumped=1;
		}
		if (parts[which][XPOS] < MIN_X) {
			parts[which][XPOS] = MAX_X;
			jumped=1;
		}
		if (parts[which][YPOS] > MAX_Y) {
			parts[which][YPOS] = MIN_Y;
			jumped=1;
		}
		if (parts[which][YPOS] < MIN_Y) {
			parts[which][YPOS] = MAX_Y;
			jumped=1;
		}
		parts[which][JUMPED] = (double)jumped;
	
	}

}

